Public Class LBEC
    ' Program to read electricity meter readings from file and produce customer invoice

    ' Filepath constant sets the full file path to be used data file storage
    Const filepath = "H:\12IS Teacher only\U3O2\Practice SAC 2007\Solution\Lightning Bolt Energy Company\"

    Dim accountnumber As Integer
    Dim Inputsok As Boolean

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        End
    End Sub
    Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click
        Dim tempradiobutton As Boolean
        Dim filename As String

        'Perform checks for correct input data TYPE
        Inputsok = True
        If Not IsNumeric(txtaccount.Text) Then
            MsgBox("Account Number must be a number")
            Inputsok = False
        End If
        If Inputsok Then 'Do a range check
            accountnumber = Val(txtaccount.Text)
            If accountnumber < 1 Or accountnumber > 699999 Then
                MsgBox("Account number must be between 1 and 699999")
                Inputsok = False
            End If
        End If
        If Inputsok Then
            ' Build up the file name and store in a string variable
            filename = filepath + "cust" + txtaccount.Text + ".txt"
            'Open the file for reading
            FileOpen(1, filename, OpenMode.Input)
            'Read each of the fields from the text file and display on the form
            txtaccount.Text = LineInput(1)
            tempradiobutton = LineInput(1) 'Store the true/false value in a boolean variable
            If tempradiobutton = True Then 'Then use this to set the values of the radio buttons
                optDom.Checked = True
                optCom.Checked = False
            Else
                optDom.Checked = False
                optCom.Checked = True
            End If
            txtprevious.Text = LineInput(1) 'Finish reading the other lines out of the text file
            txtcurrent.Text = LineInput(1)
            datPrevious.Text = LineInput(1)
            datCurrent.Text = LineInput(1)
            FileClose(1) 'Close the data file
        End If
    End Sub

    Private Sub btnCalculate_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalculate.Click
        Dim previousmeter, currentmeter, Usage As Integer
        Dim Subtotal, Surcharge, Totalcost As Decimal
        'Constant values defining the values of the Domestic and Commercial rate, the Surcharge and Costs of optional extras
        Const Domesticrate = 0.2
        Const Commercialrate = 0.15
        Const Surchargerate = 0.09
        Const surchargecutoff = 3500

        previousmeter = Val(txtprevious.Text)
        currentmeter = Val(txtcurrent.Text)

        If previousmeter > currentmeter Then ' In this case, the meter has clocked over at 99999 to 0
            Usage = (100000 - previousmeter) + currentmeter
        Else
            Usage = currentmeter - previousmeter
        End If
        If optDom.Checked = True Then
            Subtotal = Usage * Domesticrate ' Subtotal is the value of Units used, times the Constant of Domestic Rate.
        Else
            Subtotal = Usage * Commercialrate ' Subtotal is the value of Units used, times the Constant of Commercial Rate.
        End If
        If Usage > surchargecutoff Then 'See if usage level will generate a surcharge
            Surcharge = (Usage - surchargecutoff) * Surchargerate
        End If
        Totalcost = Subtotal + Surcharge 'Calculate the final cost
        ' Now display all outputs on form in currency format
        lblusage.text = Str(Usage)
        lblsubtotal.Text = Format(Subtotal, "$0.00")
        lblsurcharge.Text = Format(Surcharge, "$0.00")
        lbltotal.Text = Format(Totalcost, "$0.00")
    End Sub
End Class
