Public Class PDA
    ' Program to allow input of electricity meter readings and customer details into PDA
    ' and stored in a data file.

    ' Filepath constant sets the full file path to be used data file storage
    Const filepath = "H:\12IS Teacher only\U3O2\Practice SAC 2007\Solution\Lightning Bolt Energy Company\"

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        End
    End Sub

    Private Sub setinitial_values()
        ' Procedure to clear all text fields and set other fields to default values
        txtaccount.Text = ""
        optDom.Checked = True
        optCom.Checked = False
        txtprevious.Text = ""
        txtcurrent.Text = ""
        datPrevious.Value = Today()
        datCurrent.Value = Today()
    End Sub
    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        setinitial_values()
    End Sub

    Private Sub btnStore_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStore.Click
        Dim inputsok As Boolean
        Dim accountnumber, previousmeter, currentmeter As Integer
        Dim filename As String

        inputsok = True 'set flag which assumes all inputs are valid to begin with

        'Perform checks for correct input data TYPE
        If Not IsNumeric(txtaccount.Text) Then
            MsgBox("Account Number must be a number")
            inputsok = False
        End If
        If Not IsNumeric(txtprevious.Text) Then
            MsgBox("Previous meter reading must be a number")
            inputsok = False
        End If
        If Not IsNumeric(txtcurrent.Text) Then
            MsgBox("Current meter reading must be a number")
            inputsok = False
        End If
        If datPrevious.Value > datCurrent.Value Then ' Date time of previous must be equal or befpre the date time of current
            MsgBox("Current Date cannot be earlier than previous meter reading")
            inputsok = False
        End If

        If inputsok Then 'Do Range checks on numeric inputs
            accountnumber = Val(txtaccount.Text)
            If accountnumber < 1 Or accountnumber > 699999 Then
                MsgBox("Account number must be between 1 and 699999")
                inputsok = False
            End If
            previousmeter = Val(txtprevious.Text)
            If previousmeter < 0 Or previousmeter > 99999 Then
                MsgBox("Previous reading must be between 0 and 99999")
                inputsok = False
            End If
            currentmeter = Val(txtcurrent.Text)
            If currentmeter < 0 Or currentmeter > 99999 Then
                MsgBox("Current reading must be between 0 and 99999")
                inputsok = False
            End If
            'Check that the current date is later than previous date
            If datCurrent.Value < datPrevious.Value Then
                MsgBox("Current date cannot be before the previous date")
                inputsok = False
            End If
        End If
        If inputsok = True Then ' All TYPE and RANGE checks have passed. Go ahead with STORE
            ' Build up the file name and store in a string variable
            filename = filepath + "cust" + txtaccount.Text + ".txt"
            'Open the file for writing
            FileOpen(1, filename, OpenMode.Output)
            'Store each of the fields on a separate line of the text file
            PrintLine(1, txtaccount.Text)
            PrintLine(1, optDom.Checked)
            PrintLine(1, txtprevious.Text)
            PrintLine(1, txtcurrent.Text)
            PrintLine(1, datPrevious.Text)
            PrintLine(1, datCurrent.Text)
            FileClose(1) 'Close the data file
        End If
    End Sub

    Private Sub PDA_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        setinitial_values() 'We can use the same code as the clear button to set initial values as the form loads
    End Sub
End Class